AuctionTypein.controller('ChooseCtrl', function($scope,$rootScope,$ionicPopup,$stateParams, DataService, NetService, $debug) {
    $scope.carType = DataService.carType;
    $scope.paiType = DataService.paiType;
	$scope.shopName = NetService.getAppName();
	$scope.currentVersion = h5_version;
    $scope.canSubmit = false;
    $scope.chooseCarType = function(type){
        $scope.carType = type;
    }
    $scope.id = 0;
    //如果带着参数进来，默认进去编辑此车辆信息的逻辑
    if($stateParams.carId){
        $scope.id = $stateParams.carId;
    }
	if($scope.id && DataService.carTypeSaved===''){
		DataService.carTypeSaved =  $scope.carType;
	}
	//选择拍卖类型
    $scope.choosePaiType = function(type){
		if($scope.shopName === 'yihui'){
			type = 1;
		}
        $scope.paiType = type;
    }

	$scope.toggleLogs = function(){
		$debug.toggle();
	}
    $scope.$watch("carType",function(){
        if($scope.carType!==""&&$scope.paiType!==""){
            $scope.canSubmit = true;
        }
    })

    $scope.back = function(){
        localStorage.setItem("cheniu_pubcar_data","");
        Jockey.send('ControlWebVCBridge', {
            action: 'close'
        });

    }
    $scope.save = function(e){
        if($(e.target).hasClass("disabeld")) return;
		DataService.carType = $scope.carType

		if(location.hash.indexOf('detector')>-1){
			window.location.href = location.hash.replace('/choose','/index');
		} else if($scope.id){
			if(DataService.carTypeSaved!=='' && (DataService.carType !== DataService.carTypeSaved)){
				$ionicPopup.show({
					title: '修改车辆类型',
					template: '您确定要修改车辆类型？修改后请仔细核对车辆信息',
					buttons: [{
						text: '确定',
						type: 'button-positive theme-bg theme-border theme-color',
						onTap: function(e) {
							DataService.carTypeChange = true;
							window.location.href = "#index/"+$scope.id
						}
					},
					{
						text: '取消',
						type: '',
						onTap: function(e) {

						}
					}]
				})
			} else{
				window.location.href = "#index/"+$scope.id
			}

        } else {
			window.location.href = location.hash.replace('/choose','/index');
		}

    }
    var restoreFromLocal = function(){
        try{
            var restoredata = localStorage.getItem("cheniu_pubcar_data")
            console.log('获取回复的数据',restoredata);
            restoredata = JSON.parse(restoredata);
            return restoredata
        }catch(e){
            return null;
        }
    }
    //判断是否需要从本地恢复，然后恢复。
    var restoreData = restoreFromLocal();

    if(restoreData&&localStorage.getItem("cheniu_pubcar_data_first")){
        var myPopup = $ionicPopup.show({
            title: '判断到之前有未保存的数据，是否恢复？',
            scope: $scope,
            buttons: [
				{
					text: '重新填写',
					type: '',
					onTap: function(e) {
						localStorage.setItem("cheniu_pubcar_data","")
					}
				},
                { text: '恢复',
                    type: 'button-assertive theme-bg theme-border theme-color',
                    onTap: function(e) {
                        localStorage.setItem("cheniu_pubcar_data","")
                        restoreData.pai_data&&DataService.setPaiData(restoreData.pai_data.data);
                        restoreData.detection_data&&DataService.setDetectData(restoreData.detection_data.data)
                        restoreData.basic_data&&DataService.setBasicData(restoreData.basic_data.data)
                        restoreData.pic_data&&DataService.setPicData(restoreData.pic_data.data)
                        $scope.carType = DataService.carType = restoreData.carType;
                        $scope.paiType = DataService.paiType = restoreData.paiType;
						window.location.href = location.hash.replace('/choose','/index');
                 	}
				}

            ]
        });
    }
    if(!localStorage.getItem("cheniu_pubcar_data_first")){
        //如果是第一次判断，啥事都不干。用来去掉老的错乱数据
        localStorage.setItem("cheniu_pubcar_data_first","1")
        localStorage.setItem("cheniu_pubcar_data","")
    }
})