AuctionTypein.controllerProvider.register('IndexCtrl', function($scope,
                                               $stateParams,
                                               $rootScope,
                                               $ionicPopup,
                                               $ionicLoading,
                                               $ionicActionSheet,
											   $debug,
                                               DataService,
                                               NetService
    ) {
    $scope.carType = DataService.carType;
    if($scope.carType == 1) { // 二手车
        //DataService.paiType = 1; //$scope.paiType    //set paimai type =1 zhuanchang pai
        NetService.getPaiType(function(paiType){
            $scope.paiType = paiType;
            DataService.paiType = $scope.paiType;
			updateData()
            $scope.$digest();

        });

    }
	$scope.version = DataService.version;
	$scope.accountType = DataService.accountType;

	if(!$scope.paiType){
        $scope.paiType = 0;
        DataService.paiType = 0;
    }
	if(!$scope.accountType){
		NetService.getAccountType(function(shopId){
			$scope.accountType = DataService.accountType = shopId;
		})
	}

    $scope.result = {}

    $scope.tobaseinfo = function(){
        window.location.href="#baseinfo";
    }
	//fixed android phy return btn.
	window.whenBackPressed = function(randomId){
		if(window.CheNiu && location.hash.indexOf('#/choose') === -1){
			CheNiu.disableBack(randomId);
			if(location.hash.indexOf('#/index') > -1){
				$scope.exit();
			} else {
                console.log('点击了back按钮');
				window.history.go(-1);
			}
		}
	}
    $scope.id = '';
    //如果带着参数进来，默认进去编辑此车辆信息的逻辑
    if($stateParams.carId) {
		$scope.id = $stateParams.carId;
		$debug.log("carId: ",$stateParams.carId)
	}
	if(location.hash.indexOf('detector')>-1) {
		$scope.shopId = $stateParams.shopId;
		$scope.mobile = $stateParams.mobileNum;
		$debug.log("shopId: ",$stateParams.shopId)
		$debug.log("mobileNum: ",$stateParams.mobileNum)
	}

    $scope.canSubmit = false;
    $scope.canotSubmitReason = "信息未填写完整";
    $scope.data = {}
    $scope.hasEditThisTime = false;//本次是否编辑过
    $scope.tmp = {};
    $scope.tmp.paiFinish = false; // 用于判断是否完成了拍卖的填写
    var restoreDataStringify ;//记录没改写数据之前的数据stringify，用来比较是否有改动本次
    var saveToLocal = function(){
        $debug.log("save to local")
        $scope.data.carType = $scope.carType;
        $scope.data.paiType = $scope.paiType;
        $scope.data.version = $scope.version;
        localStorage.setItem("cheniu_pubcar_data",JSON.stringify($scope.data))
    }

	var tempSaveId = setInterval(function(){
		updateData();
		saveToLocal()
	}, 30000);

    //更新当前scrope的数据，根据
    var updateData = function(){
        $scope.data.pai_data = DataService.getPaiData();
        $scope.data.detection_data = DataService.getDetectData()
        $scope.data.basic_data=DataService.getBasicData(),
        $scope.data.pic_data=DataService.getPicData()
        $scope.carType = DataService.carType;
        $scope.paiType = DataService.paiType;
        $scope.version = DataService.version;
        $scope.data.others = DataService.getCommentData();
        $scope.data.others_short = DataService.getCommentData() ? DataService.getCommentData().length > 12 ? DataService.getCommentData().slice(0, 12) + '...' : DataService.getCommentData() : '';
	}

    function getVerNum(str){
        return Number(str.split('.').join(''));
    }

    // 原生图片上传
    $scope.nativePicUpload = function(){

        try{
            var appVersion = window.CheNiu && CheNiu.getAppVersion && CheNiu.getAppVersion().match(/(\d\.){3}\d/g)[0];
            var nativeVersion = appVersion.replace(/\./g,"")*1;
        }catch(e){
            var nativeVersion = 0;

        }

        // 判断版本,选择原生还是h5
        if (nativeVersion < 972) {
            console.log('旧版本跳转');
            location.href = "#uploadpics";
        } else {
            console.log('新版本跳转');
            var nativeImages = DataService.getPicData().data;
            console.log("kkk调用上传图片,之前的图片是:",nativeImages);
            var uploadStr = nativeImages.join(',');

            if(typeof CheNiu != "undefined"){
                CheNiu.uploadCarImages(uploadStr);
            }
        }
    }

    if(window.CheNiu&&CheNiu){
        CheNiu.uploadCarImagesCallback = function(filePaths){
            var images = [];
            if(filePaths){
                filePaths = filePaths.split(",")
                filePaths.forEach(function(filepath){
                    images.push(filepath);
                });
            }
            DataService.setPicData(images);
            updateData();
            $scope.$digest();
            console.log('kkk执行完毕,传到dataService的是:'+JSON.stringify(images));
        }
    }


    console.log('进入indexCtrl'+JSON.stringify(DataService.getPicData()));
    console.log('进入indexCtrl'+JSON.stringify($scope.data.pic_data));
    updateData();


    restoreDataStringify = JSON.stringify($scope.data);
    if($scope.id){
       //从线上恢复数据
        $ionicLoading.show({
            template: '加载中...'
        });
       NetService.restoreFromOnline($scope.id,function(error,data){
		   $ionicLoading.hide();
           if(error){
               alert(error.message)
           }else{
			   //遍历所有的字段，把纯数字的字符串变成number
               function allnum(obj){
                   for(var i in obj){
					   if(typeof(obj[i])=="object"){
                           arguments.callee(obj[i])
                       }else if(typeof(obj[i])=="string"){
                            if(/^[0-9.]+$/.test(obj[i])&&i!=='authshop_id'&& i.indexOf('province') < 0 && i.indexOf('city') < 0 && i!=='modification_tips'){
                                obj[i] = obj[i]*1;
                            }
                       }else{

                       }
                   }

               }
			   if(data.data.basic){
				   $scope.id = data.data.basic.id;
				   NetService.convertUnitToWan(data.data.basic, 'mileage');
				   NetService.convertUnitToWan(data.data.basic, 'original_price');
				   if(data.data.basic.from_detector){
					   $scope.shopId = data.data.basic.authshop_id; //放在allnum之前，防止shopId被转化成数字
					   $scope.mobile = data.data.basic.holder_mobile;
				   } else {
					   delete data.data.basic.authshop_id;
				   }
			   }
               allnum(data.data);
			   if(data.data.procedure && NetService.getAppName() === 'yihui') {
				   if(data.data.procedure.cost_price){
					   DataService.setPriceData(data.data.procedure.cost_price);
				   } else {
					   data.data.procedure.cost_price = {};
				   }
			   }

               if (data.data.procedure && data.data.procedure.others) {
                    $scope.data.others = data.data.procedure.others;
               }

               if (data.data.procedure && data.data.procedure.car_keys) {
                    data.data.procedure.car_keys = '' + data.data.procedure.car_keys;
               }

               if (data.data.basic && data.data.basic.modification_tips) {
                    data.data.basic.modification_tips = '' + data.data.basic.modification_tips;
               }


               DataService.setBasicData({
                   basic:data.data.basic,
                   procedure:data.data.procedure,
                   configuration:data.data.configuration
               })
			   DataService.getBasicData();//for data couts show in index page.
               DataService.setPicData(data.data.basic.pictures?data.data.basic.pictures.split(","):[])
               //DataService.paiType = data.data.auction.auction_type;
			   $scope.version = DataService.version = data.data.basic.version;
			   DataService.setDetectData(data.data.detection);

               //delete data.data.auction.auction_type;
               if(data.data.auction){
				   data.data.auction.authshop_id ? (delete data.data.auction.authshop_id) : '';
                   NetService.convertUnitToWan(data.data.auction, 'open_price');
                   NetService.convertUnitToWan(data.data.auction, 'reserve_price');
				   if(data.data.auction.commission){
					   NetService.convertUnitToWan(data.data.auction, 'commission');
				   }
                   if(data.data.auction.personal_seller && data.data.auction.personal_seller.expected_price){
                       NetService.convertUnitToWan(data.data.auction.personal_seller, 'expected_price');
                   }
               }
               DataService.setPaiData({
                   auction:data.data.auction
               })
				if(!DataService.carTypeChange){
					if(data.data.basic.car_type=="used_car"){
						DataService.carType = 1;
					}else{
						DataService.carType = 0;
					}
				}

               updateData()
           }
       })
    }else{

    }

    $rootScope.$on('$stateChangeStart',
    function (event, toState, toParams, fromState, fromParams) {
        if (toState.name.indexOf("/index")!=-1) {
            updateData();//更新数据
            saveToLocal();//每次切换到首页备份一次数据
        }

    })

    console.log(DataService.getCommentData());
    //向服务器保存,每次提交会提取图片，上传，然后替换成线上url，保存。
    $scope.save = function(){
		saveToLocal();
        var pics = [];
        try{
            //基础图片
            $scope.data.pic_data.data.forEach(function(p){
                if(p.indexOf("http://")==-1){
                    pics.push(p)
                }
            })
        }catch(e){
			$debug.warn('upload image abnormal: ',e)
        }
        try{
            //从检测里提取图片信息
            for(var d in $scope.data.detection_data.data){
                var detectItem = $scope.data.detection_data.data[d]
                for(var dd in detectItem){
                    var detectitem = detectItem[dd]
                    if(detectitem&&detectitem.images){
                        var images = detectitem.images.split(",")
                        images.forEach(function(img){
                            if(img.indexOf("http://")==-1){
                                pics.push(img)
                            }
                        })
                    }
                }
            }
        }catch(e){

        }

        NetService.savePics(pics,function(picObj){
            //记录图片kv
            try{
               for(var i in picObj){
                   DataService.pics_uploaded.push(i);
               }
            }catch(e){

            }
            //把线上图片地址回填到data中，并同步到dataservice，
            // 如果图片没有在回调列表里，则删除之防止最后结果里出现file协议的图片，后台会报错。
            try{

                for(var i=0;i<$scope.data.pic_data.data.length;i++){
                    var p = $scope.data.pic_data.data[i];
                    if(picObj[p]){
                        $scope.data.pic_data.data[i]=picObj[p]
                    }
//                    else if(p.indexOf("http://")==-1){
//						//如果没有在成功的列表里并且是本地路径，就把图片删掉。S
//                        $scope.data.pic_data.data.splice(i,1)
//                        i--;
//                    }
                }
                DataService.setPicData($scope.data.pic_data.data)
            }catch(e){
                console.trace(e)
            }

            try{
                //恢复检测里的图片
                for(var d in $scope.data.detection_data.data){
                    var detectItem = $scope.data.detection_data.data[d]
                    for(var dd in detectItem){
                        var detectitem = detectItem[dd]
                        if(detectitem&&detectitem.images){
                            var images = detectitem.images.split(",")
                            for(var i=0;i<images.length;i++){
                                var p = images[i];
                                if(picObj[p]){
                                    images[i]=picObj[p]
                                }
//                                else if(p.indexOf("http://")==-1){
//                                    images.splice(i,1)
//                                    i--;
//                                }
                            }
                            detectitem.images = images.join(",")
                        }
                    }
                }
                DataService.setDetectData($scope.data.detection_data.data)
            }catch(e){
                console.trace(e)
            }
            var result = generateResult();
            $ionicLoading.show({
                template: '保存中...'
            });
            restoreDataStringify = JSON.stringify($scope.data)
            console.log(result);
            NetService.saveToOnline(result,function(error,data){
                $ionicLoading.hide();
				if(tempSaveId) clearInterval(tempSaveId);
                if(error){
                    var alertPopup = $ionicPopup.alert({
                        title: error.message
                    });
                }else{
                    if(data.data.id){
                        $scope.id = data.data.id;
                        $ionicLoading.show({
                            template: '保存成功',
                            duration:2000
                        });
//                        $debug.log("后台返回是否可以提交：",data.data.can_submit);
						$debug.log('save: ',data.message);

                        if(data.data.can_submit && ($scope.data.basic_data.type_count>=$scope.data.basic_data.total_count)){
                            $scope.canSubmit = true;
                        }else{
                            $scope.canotSubmitReason = data.message;
                        }
						localStorage.setItem("cheniu_pubcar_data","");
						DataService.carTypeChange = false;
					}else{
                        $ionicLoading.show({
                            template: '系统错误',
                            duration:2000
                        });
                    }

                }
            })
        })

    }
    //图片上传完了之后，把之前的图片替换掉
    var picSaveCallback = function(){

    }
    //生成最后格式的json
    var generateResult = function(){
		$debug.log('scope.id: ',$scope.id)
		var result = {};
        result.auction = $scope.data.pai_data.data.auction||{};
        result.basic = $scope.data.basic_data.data.basic||{};
        result.procedure = $scope.data.basic_data.data.procedure||{};
        result.configuration = $scope.data.basic_data.data.configuration||{};
        result.detection = $scope.data.detection_data.data||{}
		result.basic.version =  $scope.version || DataService.version;
		if(this.carTypeChange && this.carType === 0){
			delete result.detection;
		}
		for(var d in result.detection){
            var detectItem = result.detection[d]
            for(var dd in detectItem){
                var detectitem = detectItem[dd]
                if(detectitem&&detectitem.images){
                    var images = detectitem.images.split(",")
                    for(var i=0;i<images.length;i++){
                        var p = images[i];
                        if(p.indexOf("http://")==-1){
                            images.splice(i,1)
                            i--;
                        }
                    }
                    detectitem.images = images.join(",")
                }
            }
        }
        var pictures = [];
        if($scope.data.pic_data.data){
            for(var i =0;i<$scope.data.pic_data.data.length;i++){
                if($scope.data.pic_data.data[i].indexOf("http://")!=-1){
                    pictures.push($scope.data.pic_data.data[i])
                }
            }
        }
        result.basic.pictures = pictures.join(",")||"";

		if(NetService.getAppName() === 'yihui'){
			$scope.paiType = 1;
            DataService.paiType = $scope.paiType;
		}

        //result.auction.auction_type = $scope.paiType;

        result = $.extend(true,{},result)
        delete result.auction.is_daipai;
        if($scope.id || result.auction.id){
           result.id =  result.basic.id || $scope.id;
			delete result.basic.id;
        }
		DataService.carTypeSaved = $scope.carType;

		if($scope.carType==1){ // 二手车
            result.basic.car_type ="used_car"

			if($scope.data.detection_data.type_count==0){
				result.basic.has_detection = false;
			}else{
				result.basic.has_detection = true;
			}
        }else{
			result.basic.has_detection = false;
            result.basic.car_type ="new_car"
        }

        if(result.auction){
            NetService.convertUnitToYuan(result.auction, 'open_price');
            NetService.convertUnitToYuan(result.auction, 'reserve_price');
			if(result.auction.commission){
				NetService.convertUnitToYuan(result.auction, 'commission');
			}
            if(result.auction.personal_seller && result.auction.personal_seller.expected_price){
                NetService.convertUnitToYuan(result.auction.personal_seller, 'expected_price');
                $debug.log("保存后的值！",result.auction.personal_seller.expected_price);
            }
        }
		if(result.basic){
			NetService.convertUnitToYuan(result.basic, 'mileage');
			NetService.convertUnitToYuan(result.basic, 'original_price');
		}
		if(location.hash.indexOf('detector')>-1){
			result.basic.from_detector = true;
			result.basic.authshop_id = $scope.shopId;
			result.basic.holder_mobile = $scope.mobile;
		}

		if(!(result.basic.version>=5)){
			result.basic && (result.basic.others='');
			result.configuration && (result.configuration.others='');
		}

        if(result.auction.p_seller===''){
            delete result.auction.p_seller;
        }

        if(result.basic.price){
            delete result.basic.price;
        }
        return result;
    }
    $scope.submit = function(){

        if(!$scope.canSubmit) return; // 预防处理
        if($scope.data.carType===1 && $scope.data.detection_data.description!="已完成") { // 两种拍卖均有
            var myPopup = $ionicPopup.show({
                title: '您未填写检测信息，该车只能被安排到现场拍卖，仍要提交审核吗',
                scope: $scope,
                buttons: [
                    { text: '取消',
                        type: '',
                        onTap: function(e) {
                            // do nothing...
                        }},
                    {
                        text: '确定',
                        type: 'button-assertive theme-bg theme-border theme-color',
                        onTap: function(e) {
                            $scope.paiType = 1;
                            DataService.paiType = $scope.paiType;
                            submitAll();
                        }
                    }
                ]
            });
        }else{
            submitAll();
        }
    }

        // 实际上提交的方法
    var submitAll = function(){
        if($scope.canSubmit){

            NetService.submitReview($scope.id,function(error,data){
                if(error){
                    var alertPopup = $ionicPopup.alert({
                        title: error.message
                    });
                }else{
                    var alertPopup = $ionicPopup.alert({
                        title: "提交成功"
                    });
                    window.CheNiu&&CheNiu.close()
                }
            })
        }else{
            var alertPopup = $ionicPopup.alert({
                title: $scope.canotSubmitReason
            });
        }
    };


    //点击返回退出的时候
    $scope.exit = function(){
        var nowDataStringify = JSON.stringify($scope.data)
        if(nowDataStringify!=restoreDataStringify){
            //本次有改动
            var hideSheet = $ionicActionSheet.show({
                buttons: [
                    { text: '保存',
                        type: ''
                    },
                    {
                        text: '不保存',
                        type: ''
                    }
                ],
                titleText: '本次有修改数据，是否保存？',
                cancelText: '取消',
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    if(index==0){
                        $scope.save();

                    }else if(index==1){
                        localStorage.setItem("cheniu_pubcar_data","");
                        DataService.setPicData([]);
						if(tempSaveId) clearInterval(tempSaveId);
                        if($scope.id){

                            location.hash="#choose/"+$scope.id
                        }else{
                            location.hash="#choose"
                        }
                    }
                    return true;
                }
            });
        }else{
            localStorage.setItem("cheniu_pubcar_data","")
			if(tempSaveId) clearInterval(tempSaveId);

            if($scope.id){
                location.hash="#choose/"+$scope.id
            }else{
                location.hash="#choose"
            }
        }

    }
//    $scope.$on("")
})
