AuctionTypein.config(function($stateProvider, $urlRouterProvider) {
    $stateProvider.state('/detection', {
            url: '/detection',
            templateUrl: '../common/common_template/detection.html'
        }
    );
    $stateProvider.state('/detection/:carId', {
            url: '/detection/:carId',
            templateUrl: '../common/common_template/detection.html'
        }
    );
    $stateProvider.state('/detection-level', {
            url: '/detection-level',
            templateUrl: '../common/common_template/detectionLevel.html'
        }
    );
    $stateProvider.state('/baseinfo', {
            url: '/baseinfo',
            templateUrl: '../common/common_template/baseinfo.html',
            controller: 'BaseCtrl'
        }
    );
    $stateProvider.state('/baseinfo/:carId', {
            url: '/baseinfo/:carId',
            templateUrl: '../common/common_template/baseinfo.html',
            controller: 'BaseCtrl'
        }
    );

    $stateProvider.state('/paiinfo', {
            url: '/paiinfo',
            templateUrl: '../common/common_template/paiinfo.html'
        }
    );

    $stateProvider.state('/comment', {
            url: '/comment',
            templateUrl: '../common/common_template/commentInfo.html',
            controller: 'commentInfoCtrl'
        }
    );
$stateProvider.state('/comment/:id', {
            url: '/comment/:id',
            templateUrl: '../common/common_template/commentInfo.html',
            controller: 'commentInfoCtrl'
        }
    );
    $stateProvider.state('/paiinfo/:carId', {
            url: '/paiinfo/:carId',
            templateUrl: '../common/common_template/paiinfo.html'
        }
    );
    $stateProvider.state('/uploadpics', {
            url: '/uploadpics',
            templateUrl: '../common/common_template/uploadPics.html'
        }
    );
    $stateProvider.state('/index', {
            url: '/index',
            templateUrl: 'templates/index.html',
            controller: "IndexCtrl",
            resolve: {deps: AuctionTypein.loadDeps("js/IndexCtrl.js")}
        }
    );
	$stateProvider.state('/index/detector/:shopId/:mobileNum', {
			url: '/index/detector/:shopId/:mobileNum',
			templateUrl: 'templates/index.html',
			controller: "IndexCtrl",
			resolve: {deps: AuctionTypein.loadDeps("js/IndexCtrl.js")}
		}
	);
	$stateProvider.state('/index/detector/:shopId/:mobileNum/:carId', {
			url: '/index/detector/:shopId/:mobileNum/:carId',
			templateUrl: 'templates/index.html',
			controller: "IndexCtrl",
			resolve: {deps: AuctionTypein.loadDeps("js/IndexCtrl.js")}
		}
	);
    $stateProvider.state('/index/:carId', {
            url: '/index/:carId',
            templateUrl: 'templates/index.html',
            controller: "IndexCtrl",
            resolve: {deps: AuctionTypein.loadDeps("js/IndexCtrl.js")}
        }
    );
    $stateProvider.state('/choose', {
            url: '/choose',
            templateUrl: 'templates/choosetype.html'
        }
    );
    $stateProvider.state('/choose/:carId', {
            url: '/choose/:carId',
            templateUrl: 'templates/choosetype.html'
        }
    );
	$stateProvider.state('/choose/detector/:shopId/:mobileNum', {
			url: '/choose/detector/:shopId/:mobileNum',
			templateUrl: 'templates/choosetype.html'
		}
	);
	$stateProvider.state('/choose/detector/:shopId/:mobileNum/:carId', {
			url: '/choose/detector/:shopId/:mobileNum/:carId',
			templateUrl: 'templates/choosetype.html'
		}
	);
    // default route
    $urlRouterProvider.otherwise('choose');
});
