(function(){

    AuctionTypein.controller('DetectionLevelCtrl',
        function(
            $scope,
			$debug,
			$ionicScrollDelegate,
            LevelStoreService,
            DataService
        ){
			Jockey.send("SetRightBar",{
				title:"完成",
				show: 1
			})
			Jockey.send("SetWebViewTitle",{
				title: '车辆评级'
			});
			window.rightButtonEvent = function(){
				$scope.saveLevel();
			}
			$scope.pageName = '车辆评级';
			$scope.isModifyLevel = false;
			var setSelectedRank = function(groupName, ranks){
				$scope.levelDefineData.forEach(function(group, index){
					if(group.name == groupName){
						group.selected = ranks;
					}
				});
			}
			var getAutoRank = function(){
				LevelStoreService.getLevelDefine(function(defineData){
					var DeData = DataService.detection_data;
					if(DeData) {
						LevelStoreService.getCurrentLevel(JSON.stringify(DeData), function(res){
							if(res.success){
								LevelStoreService.importData(DeData);
								$scope.rankLevel = res.data.general.rank + res.data.general.cost; //should get rank level from the server;
								LevelStoreService.setLevel('ranks', res.data.general.rank);
								LevelStoreService.setLevel('costs', res.data.general.cost);
                				LevelStoreService.setLevel('zhibao_rank', res.data.guarantee.rank+res.data.guarantee.cost);
								$scope.levelDefineData = LevelStoreService.consLevelData(defineData, LevelStoreService);

								if(DeData.conclusion && DeData.conclusion.self_rank){

									setSelectedRank('ranks',DeData.conclusion.self_rank);
									setSelectedRank('costs',DeData.conclusion.self_cost);
									$scope.selfLevel = DeData.conclusion.self_rank+DeData.conclusion.self_cost;
								} else {
									$scope.selfLevel = '';
								}
								$scope.remark = LevelStoreService.getRemark() || '';
                				$scope.$digest();
							} else {
								$debug.error('获取质检等级失败：',res.error);
							}
						})
					}

				});
			}
			setTimeout(getAutoRank,0);


			$scope.setRemarkVal = function(val){
				$scope.remark = val;
			}

			var self_group = {};
            $scope.chooseLevel = function($event,$index, groupName){
				if(!$scope.isModifyLevel){// 限制只有点击修改评级按钮后才可以修改评级
					return ;
				}
                var selectedRank;
                $scope.levelDefineData.forEach(function(group, index){
                    if(group.name == groupName){
                        var item = group.items[$index];
                        if( group.selected == item.rank ){
                            group.selected = null;
                        }
                        else{
                            group.selected = item.rank;
                        }
                        selectedRank = group.selected;
                    }
                });
				self_group['self_'+groupName] = selectedRank || LevelStoreService.getLevel(groupName);
            };
			$scope.changeAutoLevel = function(){
				$scope.isModifyLevel = true;
			}
			$scope.confirmEdit = function(isReady){
				if(isReady){
					var rank = self_group['self_ranks'] || LevelStoreService.getLevel('ranks');
					var cost = self_group['self_costs'] || LevelStoreService.getLevel('costs');
					LevelStoreService.setLevel('self_ranks', rank);
					LevelStoreService.setLevel('self_costs', cost);
					$scope.selfLevel = rank+cost;

				} else {
					setSelectedRank('ranks', LevelStoreService.getLevel('ranks'));
					setSelectedRank('costs',LevelStoreService.getLevel('costs'));
				}
				$scope.isModifyLevel = false;
				$ionicScrollDelegate.scrollTop();
			}
            $scope.goBack = function(){
                history.go(-1);
            }

            $scope.saveLevel = function(){
				LevelStoreService.setRestDefault();
				LevelStoreService.saveRemark($scope.remark);
				DataService.setLevelData( LevelStoreService.exportData() );
                history.go(-2);
                // console.log(DataService.detection_data);
            }
    });
})();