AuctionTypein.controllerProvider.register('IndexCtrl', function($scope,
                                               $stateParams,
                                               $rootScope,
                                               $ionicPopup,
                                               $ionicLoading,
                                               $ionicActionSheet,
                                               DataService,
                                               NetService
    ) {
    $scope.carType = DataService.carType;
    $scope.paiType = DataService.paiType;
    if(!$scope.paiType){
        $scope.paiType = 0;
        DataService.paiType = 0;
    }
	//fixed android phy return btn.
	window.whenBackPressed = function(randomId){
		if(window.CheNiu && location.hash.indexOf('#/choose') === -1){

			if(location.hash.indexOf('#/index') > -1){
				$scope.exit();
			} else {
				window.history.go(-1);
			}
		}
	}
    $scope.result = {

    }
    $scope.tobaseinfo = function(){
        window.location.href="#baseinfo"
        console.time("click to baseinfo")
    }

    $scope.id = 0;
    //如果带着参数进来，默认进去编辑此车辆信息的逻辑
    if($stateParams.editid){
        $scope.id = $stateParams.editid;
    }
    if($stateParams.seller){
        $scope.seller_phone = $stateParams.seller;
    }
    if($stateParams.carId){
        $scope.carId = $stateParams.carId;
    }
    if($stateParams.orderId){
        $scope.orderId = $stateParams.orderId;
    }
    if($stateParams.onlyBasic){
        $scope.onlyBasic = true;
    }else{
        $scope.onlyBasic = false;
    }
    $scope.canSave = true;
    $scope.canSubmit = false;
    $scope.canotSubmitReason = "信息未填写完整";
    $scope.data = {}
    $scope.hasEditThisTime = false;//本次是否编辑过
    var restoreDataStringify ;//记录没改写数据之前的数据stringify，用来比较是否有改动本次
    var saveToLocal = function(){
        console.log("save to local")
        $scope.data.carType = $scope.carType;
        $scope.data.paiType = $scope.paiType;
        localStorage.setItem("cheniu_pubcar_data",JSON.stringify($scope.data))
    }
    var restoreTimer = setInterval(function(){
        updateData();
        saveToLocal();
    },15000)
    //更新当前scrope的数据，根据
    var updateData = function(){
        $scope.data.pai_data = DataService.getPaiData()
        $scope.data.basic_data=DataService.getBasicData(),
        $scope.data.pic_data=DataService.getPicData()
        $scope.carType = DataService.carType;
        $scope.paiType = DataService.paiType;
             if($scope.data.basic_data.type_count>=$scope.data.basic_data.total_count
        &&$scope.data.pic_data.type_count>=6){
            $scope.canSubmit = true;
        }

        $scope.data.others_short = DataService.getCommentData() ? DataService.getCommentData().length > 12 ? DataService.getCommentData().slice(0, 12) + '...' : DataService.getCommentData() : '';

        console.log('++++');
        console.log($scope.data.basic_data)
        $scope.data.others = $scope.data.basic_data.data.basic ? $scope.data.basic_data.data.basic.others : '';
        console.log($scope.data.others,$scope.data.basic_data.basic)
    }

    updateData();
    restoreDataStringify = JSON.stringify($scope.data);
    if($scope.id){
       //从线上恢复数据
        $ionicLoading.show({
            template: '加载中...'
        });
       NetService.restoreFromOnline($scope.id,function(error,data){
           $ionicLoading.hide();
           if(error){
               alert(error.message)
           }else{
			   //遍历所有的字段，把纯数字的字符串变成number
               function allnum(obj){
                   for(var i in obj){
                       if(typeof(obj[i])=="object"){
                           arguments.callee(obj[i])
                       }else if(typeof(obj[i])=="string"){
                            if(/^[0-9.]+$/.test(obj[i])&&i!=='authshop_id'&& i.indexOf('province') < 0 && i.indexOf('city' < 0 ) && i!=='modification_tips'){
                                obj[i] = obj[i]*1;
                            }
                       }else{

                       }
                   }

               }
               data.data = data.car;
               allnum(data.data);

			   if(data.data.basic){
				   $scope.id = data.data.id;
				   NetService.convertUnitToWan(data.data.basic, 'mileage');
				   NetService.convertUnitToWan(data.data.basic, 'original_price');
				   NetService.convertUnitToWan(data.data.basic, 'price');
				   NetService.convertUnitToWan(data.data.basic, 'pifa_price');
			   }
               DataService.setBasicData({
                   basic:data.data.basic,
                   procedure:data.data.procedure,
                   configuration:data.data.configuration
               })
               $scope.seller_phone = data.data.seller_phone;
               $scope.userId = data.data.userId;
               $scope.carId = data.data.carId;
               if(data.data.orderId){
                 $scope.orderId = data.data.orderId;
               }
               if(data.data.onlyBasic){
                    $scope.onlyBasic = true;
               }
               DataService.setPicData(data.data.basic.pictures?data.data.basic.pictures.split(","):[])
               if(data.data.basic.car_type=="used_car"){
                   DataService.carType = 1;
               }else{
                   DataService.carType = 0;
               }

               updateData()
           }
       })
    }else{

    }

    

    Jockey.send("SetRightBar",{
        title:"保存",
        show: 1
    })
    Jockey.send("SetWebViewTitle",{
        title: '录入车辆'
    });
    window.rightButtonEvent = function(){
        $scope.save();
    }
    window.GoBackEvent = function(){
        $scope.exit();
        return {goback:0}
    };
    $rootScope.$on('$stateChangeStart',
        function (event, toState, toParams, fromState, fromParams) {
            if (toState.name.indexOf("/index")!=-1) {
                Jockey.send("SetRightBar",{
                    title:"保存",
                    show: 1
                })
                Jockey.send("SetWebViewTitle",{
                    title: '录入车辆'
                });

                window.rightButtonEvent = function(){
                    $scope.save();
                }
                window.GoBackEvent = function(){
                    $scope.exit();
                    return {goback:0}
                };
                // Jockey.on("GoBackEvent",function(){
                //     return 1;
                // })
                updateData();//更新数据
                saveToLocal();//每次切换到首页备份一次数据
            }else{
                window.GoBackEvent = null;
            }

        })
    //向服务器保存,每次提交会提取图片，上传，然后替换成线上url，保存。
    var startSave = function(isReview){
        var pics = [];
        try{
            //基础图片
            $scope.data.pic_data.data.forEach(function(p){
                if(p.indexOf("http://")==-1){
                    pics.push(p)
                }
            })
        }catch(e){
            console.trace(e)
        }

        NetService.savePics(pics,function(picObj){
            //记录图片kv
            try{
               for(var i in picObj){
                   DataService.pics_uploaded.push(i);
               }
            }catch(e){

            }
            //把线上图片地址回填到data中，并同步到dataservice，
            // 如果图片没有在回调列表里，则删除之防止最后结果里出现file协议的图片，后台会报错。
            try{

                for(var i=0;i<$scope.data.pic_data.data.length;i++){
                    var p = $scope.data.pic_data.data[i];
                    if(picObj[p]){
                        $scope.data.pic_data.data[i]=picObj[p]
                    }
//                    else if(p.indexOf("http://")==-1){
//						//如果没有在成功的列表里并且是本地路径，就把图片删掉。S
//                        $scope.data.pic_data.data.splice(i,1)
//                        i--;
//                    }
                }
                DataService.setPicData($scope.data.pic_data.data)
            }catch(e){
                console.trace(e)
            }

            var result = generateResult();
            $ionicLoading.show({
                template: '保存中...'
            });
            restoreDataStringify = JSON.stringify($scope.data)
            NetService.saveToOnline(result,isReview,function(error,data){
                $ionicLoading.hide();

                if(error){
                    var alertPopup = $ionicPopup.alert({
                        title: error.message
                    });
                }else{
                    clearRestore();
                    var carId = data.data.check_car_order.report_id;
                    if(carId){
                        $scope.id = carId;

                        $ionicLoading.show({
                            template: isReview?'提交成功':'保存成功',
                            duration:2000
                        });
                        if(isReview){
                            setTimeout(function(){
                                 Jockey.send('ControlWebVCBridge', {
                            action: 'close'
                        });
                            },1000)
                        }

                        if(data.data.can_submit){
                            $scope.canSubmit = true;
                        }else{
                            $scope.canotSubmitReason = data.message;
                        }
                    }else{
                        $ionicLoading.show({
                            template: '系统错误',
                            duration:2000
                        });
                    }

                }
            })
        })

    }
    //图片上传完了之后，把之前的图片替换掉
    var picSaveCallback = function(){

    }
    var clearRestore = function(){
        localStorage.setItem("cheniu_pubcar_data","");
        clearInterval(restoreTimer)
    }
    //生成最后格式的json
    var generateResult = function(){
        var result = {};

        result.basic = $scope.data.basic_data.data.basic||{};
        result.procedure = $scope.data.basic_data.data.procedure||{};
        result.configuration = $scope.data.basic_data.data.configuration||{};
        result.onlyBasic = true;
        var pictures = [];
        if($scope.data.pic_data.data){
            for(var i =0;i<$scope.data.pic_data.data.length;i++){
                if($scope.data.pic_data.data[i].indexOf("http://")!=-1){
                    pictures.push($scope.data.pic_data.data[i])
                }
            }
        }

        result.basic.pictures = pictures.join(",")||"";


        result = $.extend(true,{},result)
        if($scope.id){
            result.id = $scope.id;
        }
        if($scope.seller_phone){
            result.seller_phone= $scope.seller_phone+"";
        }
        if($scope.carType==1){
            result.basic.car_type ="used_car"
        }else{
            result.basic.car_type ="new_car"
        }
        if($scope.carId){
            result.carId = $scope.carId;
        }
        if($scope.orderId){
            result.orderId = $scope.orderId;
        }
        if($scope.onlyBasic){
            result.onlyBasic = true;
        }
        result.basic.has_detection = false;
		if(result.basic){
			NetService.convertUnitToYuan(result.basic, 'mileage');
			NetService.convertUnitToYuan(result.basic, 'original_price');
			NetService.convertUnitToYuan(result.basic, 'price');
			NetService.convertUnitToYuan(result.basic, 'pifa_price');
		}
        return result;
    }
    $scope.save = function(){
        if($scope.canSave){

                startSave(false)

        }
    }
    $scope.submit = function(){
        if($scope.canSave){

            startSave(true)

        }

    }

    //点击返回退出的时候
    $scope.exit = function(){
        var nowDataStringify = JSON.stringify($scope.data)
        if(nowDataStringify!=restoreDataStringify){
            //本次有改动
            var hideSheet = $ionicActionSheet.show({
                buttons: [
                    { text: '保存',
                        type: ''
                    },
                    {
                        text: '不保存',
                        type: ''
                    }
                ],
                titleText: '本次有修改数据，是否保存？',
                cancelText: '取消',
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    if(index==0){
                        $scope.save();

                    }else if(index==1){
                        clearRestore()
                         Jockey.send('ControlWebVCBridge', {
                            action: 'close'
                        });
                    }
                    return true;
                }
            });
        }else{
            clearRestore()
            Jockey.send('ControlWebVCBridge', {
                            action: 'close'
                        });
        }

    }
    var restoreFromLocal = function(){
        try{
            var restoredata = localStorage.getItem("cheniu_pubcar_data")
            restoredata = JSON.parse(restoredata);
            return restoredata
        }catch(e){
            return null;
        }
    }
    //判断是否需要从本地恢复，然后恢复。
    var restoreData = restoreFromLocal();
    if((!$scope.id)&&restoreData&&localStorage.getItem("cheniu_pubcar_data_first")){
        var myPopup = $ionicPopup.show({
            title: '判断到之前有未保存的数据，是否恢复？',
            scope: $scope,
            buttons: [
                { text: '恢复',
                    type: '',
                    onTap: function(e) {
                        localStorage.setItem("cheniu_pubcar_data","");
                        restoreData.basic_data&&DataService.setBasicData(restoreData.basic_data.data)
                        restoreData.pic_data&&DataService.setPicData(restoreData.pic_data.data)
                        //$scope.$digest();
                        updateData()
                    }},
                {
                    text: '重新填写',
                    type: 'button-assertive theme-bg theme-border theme-color',
                    onTap: function(e) {
                        localStorage.setItem("cheniu_pubcar_data","");
                    }
                }
            ]
        });
    }
    if(!localStorage.getItem("cheniu_pubcar_data_first")){
        //如果是第一次判断，啥事都不干。用来去掉老的错乱数据
        localStorage.setItem("cheniu_pubcar_data_first","1")
        localStorage.setItem("cheniu_pubcar_data","");
    }
//    $scope.$on("")
})
