AuctionTypein.controller('PaiCtrl', function ($scope, DataService, $ionicPopup, $timeout, NetService) {
    $scope.data = DataService.getPaiData().data;
    //本地发生编辑行为
    $scope.hasChangeThisTime = false;
	$scope.paiType = DataService.paiType;
	$scope.carType = DataService.carType;
    $scope.data.is_daipai = 0;
	$scope.isAutoPrice = false;
	$scope.car_types = [{id: 'self',name: "个人置换车"},{id:'try',name:'试乘试驾'}];
	$scope.tmp = {};
	$scope.tmp.p_feedback = DataService.paiFeedBack; // 用于判断是否返回保留价(佣金计算接口)
	$scope.tmp.commission = $scope.data.auction.commission; // 用于再次进入时提供佣金显示
	var shopName = NetService.getAppName();
	var shopType = DataService.getAccountType();

	//console.log($rootScope.protectPrice);
    //延时绑定值变化函数
	$timeout(function(){
			$scope.$watch("data",function(){
            $scope.hasChangeThisTime=true;
        },true)
    },2000);
//	$timeout(function(){
//		NetService.getContactor(function(param){
//			if(param.message === "OK"){
//				$scope.dat	a.auction.contact = param.data.name;
//				$scope.data.auction.contact_mobile = param.data.phone*1;
//			}
//		});
//		NetService.getUserType(function(param){
//		})
//    },0);

	// 反馈时间数组
	if(!$scope.resTimes){
		var innerDate = new Date();
			var innerMins = innerDate.getHours()*60 + innerDate.getMinutes()*1;
			if (innerMins < (9*60+30)) { // 9:30前
				$scope.resTimes = 1;
			} else if (innerMins < 18*60) { //  9:30－18:00
				$scope.resTimes = 2;
			} else { // 18:00-24:00
				$scope.resTimes = 3;
			}
	}

	$timeout(function (){
		if($scope.carType===1 && shopType==='000139'){
			$scope.isAutoPrice = true;
			var basicData = DataService.getBasicData().data;
			var DetectData = DataService.getDetectData().data;
			var dataJson = {};
			var errArr =[];
			if(basicData.basic && basicData.basic.model_code){
				dataJson.model = basicData.basic.model_code;
			} else {
				errArr.push('品牌车系');
			}
			if(basicData.basic && basicData.basic.mileage){
				dataJson.mileage = basicData.basic.mileage;
			} else {
				errArr.push('里程');
			}
			if(basicData.basic && basicData.basic.begin_at){
				dataJson.begin_at = basicData.basic.begin_at;
			} else {
				errArr.push('初次上牌');
			}
			if(basicData.basic && basicData.basic.use_nature){
				dataJson.use_nature = basicData.basic.use_nature;
			} else {
				errArr.push('使用性质');
			}
			if(DetectData.conclusion &&  DetectData.conclusion.detection_rank && DetectData.conclusion.detection_cost){
				dataJson.rank = DetectData.conclusion.detection_rank +':'+ DetectData.conclusion.detection_cost;
			} else {
				errArr.push('检测评级');
			}
			if(errArr.length > 0){
				$ionicPopup.alert({
					title: '提示',
					template: '请先填写'+errArr,
					buttons: [{
						text: '我知道了',
						type: 'button-positive'
					}]
				}).then(function(){
					errArr.length=0;
				})
			} else {
				NetService.getDelegatePrice(dataJson, function(rtn){
					if(rtn.message === "OK" && rtn.data && rtn.data.start_price!=='' && rtn.data.reserve_price !==''){
						$scope.data.auction.open_price= (rtn.data.start_price/10000).toFixed(2)*1 ;
						$scope.data.auction.reserve_price= (rtn.data.reserve_price/10000).toFixed(2)*1;
					} else {
						$scope.isAutoPrice = false;
						$scope.data.auction.open_price = $scope.data.auction.open_price || '';
						$scope.data.auction.reserve_price = $scope.data.auction.reserve_price || '';
					}
				})
			}

		}
		//if((shopName === 'yihui') && (DataService.carType===1)){
		//	$scope.$watch("data.auction.reserve_price" ,function(){
		//		if($scope.data.auction.reserve_price){
		//			var price_o = DataService.getPriceData();
		//			var showTips = true;
		//			if(price_o &&  price_o.purchase !==null && price_o.reconditioning!==null){
		//				var transfer_fee = price_o.transfer_or_mention || 0;
		//				var purchase_price = price_o.purchase;
		//				var reconditioning_fee = price_o.reconditioning;
		//				if(!isNaN(transfer_fee) && !isNaN(purchase_price) && !isNaN(reconditioning_fee)){
		//					var basePrice = ((purchase_price*1.05 + reconditioning_fee*1 + transfer_fee*1)/10000).toFixed(2)*1;
		//						if($scope.data.auction.reserve_price > basePrice) {
		//							$scope.isDialogExist = true;
		//							$ionicPopup.alert({
		//								title: '提示',
		//								template: '你输入的保留价过高，根据该车收购价，您设定的保留价不能超过'+basePrice+'万',
		//								buttons: [{
		//									text: '我知道了',
		//									type: 'button-positive'
		//								}]
		//							}).then(function(){
		//								$scope.isDialogExist = false;
		//							})
		//							$scope.data.auction.reserve_price = basePrice;
		//						}
		//					showTips = false;
		//				} else {
		//					showTips = true;
		//				}
        //
		//			} else {
		//				showTips = false;
		//			}
		//			if(showTips) {
		//				$scope.isDialogExist = true;
		//				$ionicPopup.alert({
		//					title: '提示',
		//					template: '请您先在【车辆信息】中填写 “VIN码” 和 “过户/提档费用',
		//					buttons: [{
		//						text: '我知道了',
		//						type: 'button-positive'
		//					}]
		//				}).then(function(){
		//					$scope.isDialogExist = false;
		//				})
		//				$scope.data.auction.reserve_price = '';
		//			}
		//		}
		//	}, true)
		//}
		if($scope.data.auction && $scope.data.auction.p_seller==2 && $scope.data.auction.personal_seller &&  $scope.data.auction.personal_seller.expected_price){
			$scope.calPrice();
		}
		if($scope.data.auction.p_seller){
			$scope.data.auction.p_seller = $scope.data.auction.p_seller+"";
		}else{
			$scope.data.auction.p_seller = "";
		}
	},0);

	$scope.save = function(){

        if($scope.data.auction && ($scope.data.auction.open_price>1000 || $scope.data.auction.reserve_price>1000)){
			$ionicPopup.alert({
				title: '价格设置异常',
				template: '起拍价和保留价的单位是万，请检查并重新输入',
				buttons: [{
					text: '我知道了',
					type: 'button-positive'
				}]
			}).then(function(){
				$scope.data.auction.open_price = ''
			})
//			$scope.data.auction.open_price = ($scope.data.auction.open_price/10000).toFixed(2)*1
        } else {
			DataService.setPaiData($scope.data);
			window.history.go(-1);
		}
	}
    $scope.back = function(){
        if($scope.hasChangeThisTime){
            var myPopup = $ionicPopup.show({
                title: '当前录入的信息尚未保存，是否保存',
                scope: $scope,
                buttons: [
                    { text: '不保存',
                        type: '',
                        onTap: function(e) {
							window.history.go(-1);
						}},
                    {
                        text: '保存',
                        type: 'button-assertive theme-bg theme-border theme-color',
                        onTap: function(e) {
                            $scope.save();
                        }
                    }
                ]
            });
        }else{
			window.history.go(-1);
		}
    }

	// 获取保留价和佣金
	$scope.calPrice = function(){

		var expect = $scope.data.auction.personal_seller.expected_price;
		$scope.tmp.p_feedback = false;
		NetService.getCommissionGold(expect*10000,function(data){
			var commission =  data.commission/10000
			$scope.data.auction.reserve_price = parseFloat((commission*1 + expect*1)).toFixed(2)*1; // 意向价
			$scope.data.auction.commission = commission;
			//commission.commission = commission;
			$scope.tmp.p_feedback = true;
			DataService.paiFeedBack = $scope.tmp.p_feedback;
			$scope.$digest();
		});

	}
});