// 一个有缓存&防重复请求的数据服务
AuctionTypein.factory('LevelDefineService', function($http){
    var levelDefineData = undefined;
    var reqing = false;
    var callbackArr = [];
    window.LevelrankUrl = "http://detection-center.souche.com";
	if(window.h5_is_dev){
        LevelrankUrl = "http://detection-center.souche.com";
//		var niu_url = "http://cheniu-dev.souche.com:8001";
		var user_token =  UserInfo.token; //|| '8ea3a787311d1dbf5c284a2ecac78c47';
	} else{
		LevelrankUrl = "http://detection-center.souche.com";
//		var user_token = "d4f121532300db8e62c14ebae110a21e"
	}

	var ranksPool={"ranks":[{"rank":"A","msg":"1. 车身、底盘及骨架(不含保险杠)没有碰撞痕迹。\n2. 发动机和变速箱无异常。"},{"rank":"B","msg":"1. 前后盖、前叶子板或者车门有碰撞或者更换的痕迹,底盘轻微刮擦。\n2. 发动机和变速箱功能正常,有轻微的抖动和异响。"},{"rank":"C","msg":"1. 水箱框架、前叶子板内衬、后叶子板、后围板有更换或者修复痕迹，底盘有严重刮伤或者锈蚀。\n2. 发动机异响严重，加速无力，无高速,怠速抖动，冒黑烟。手动变速器挂档不顺畅，自动变速轻微换挡冲击或者换挡延迟。"},{"rank":"D","msg":"1. 梁架、内板、柱、防火墙有碰撞或者切割的痕迹。\n2. 发动机杂乱异响或烧机油，变速箱不走车或者严重闯档。\n3. 车辆泡水痕迹，火烧痕迹。"}],"costs":[{"rank":"++","msg":"1. 车身无明显伤痕，漆面状况为原车漆，内饰干净整洁，电器设备及仪表功能正常。"},{"rank":"+","msg":"1. 车身有细小伤痕,喷漆修复低于30%的，无钣金修复，内饰为正常使用痕迹,，有轻微污渍和磨损,主要电器设备功能正常。"},{"rank":"-","msg":"1. 车身有明显漆面伤痕或色差龟裂,需喷漆修复或者钣金修复超过30%，内饰有不易去除的污渍或磨损,部分电器设备功能需修理。"},{"rank":"--","msg":"1. 车身有多处漆面伤痕,需钣金修复;内饰大面积污损或部件缺失破损,多种电器功能失效需更换。"}]}
    return {
        getLevelData: function(callback){
            if(reqing){
                callbackArr.push(callback);
                return;
            }
            if(levelDefineData){
                setTimeout(function(){
                    callback(levelDefineData);
                });
            }
            else{
                callbackArr.push(callback);
				reqing = false;
				levelDefineData = ranksPool;
				while(callbackArr.length>0){
					callbackArr.shift()(ranksPool);
				}
            }
        }
    }
});

AuctionTypein.factory('LevelStoreService', function(LevelDefineService, $http){
    var levelData = {};
    // obj: { groupName: selectedRank }

    var levelDefineData = undefined;
    LevelDefineService.getLevelData(function(data){
        levelDefineData = data;
    });
    return {
		consLevelData: function(data){
			var arr = [];
			var leStore = this;

			arr.push({
				name: 'ranks',
				text: '综合车况',
				items: data['ranks'],
				selected: leStore.getLevel('ranks')
			});
			arr.push({
				name: 'costs',
				text: '整备成本',
				items: data['costs'],
				selected: leStore.getLevel('costs')
			});

			return arr;
		},
        getLevelDefine: function(callback){
            LevelDefineService.getLevelData(callback);
        },
		getCurrentLevel: function(detectionData, callback){
            $.ajax({
                type:"post",
                url:window.LevelrankUrl+'/detection/report/rank' ,
                data:{report_json:detectionData,report_type:"ALL"},
                success:function(res){
                    console.log(res)
                    callback(res)
                }
            })
		},
        getSupportLoan:function(){
            $.ajax({
                type:"post",
                url:window.LevelrankUrl+'/detection/report/rank' ,
                data:{report_json:detectionData,report_type:"ALL"},
                success:function(res){
                    console.log(res)
                    callback(res)
                }
            })
        },
        getLevel: function(groupName){
            return levelData[groupName];
        },
        getDefaultLevel: function(groupName){
            return levelDefineData[groupName][0].rank;
        },
        getRemark: function(){
            return levelData['remark'] || '';
        },
        setLevel: function(groupName, levelName, noInstantSave){
            if(levelName !== undefined){
                levelData[groupName] = levelName;
            }
            // else{
            //     if(!levelDefineData || !levelDefineData[groupName]){
            //         LevelDefineService.getLevelData(function(data){
            //             levelData[groupName] = levelDefineData[groupName][0].rank;
            //         });
            //     }
            //     else{
            //         // levelData[groupName] = levelDefineData[groupName][0].rank;
            //     }
            // }

            if(!noInstantSave){
                this.save();
            }
        },
        saveRemark: function(remark){
            levelData.remark = remark;
            this.save();
        },
        save: function(){
            // window.localStorage['detection-level'] = JSON.stringify(levelData);
        },
        setRestDefault: function(){
            ['ranks', 'costs'].forEach(function(group){
                if(!levelData[group]){
                    this.setLevel(group);
                }
            }.bind(this));
            this.save();
        },
        exportData: function(){
            var leStore = this;
            var rank = leStore.getLevel('ranks');
            var cost = leStore.getLevel('costs');
			var self_rank = leStore.getLevel('self_ranks');
			var self_cost = leStore.getLevel('self_costs');
            var zhibao_rank = leStore.getLevel('zhibao_rank');
            return {
                "detection_rank": self_rank || rank,
                "detection_cost": self_cost || cost,
				"self_rank": self_rank,
				"self_cost": self_cost,
                "zhibao_rank":zhibao_rank,
                "detection_conclusion_comment": leStore.getRemark()
            };
        },
        importData: function(serverData){
            var leStore = this;
            var serverLevelData = serverData.conclusion;
            if(!serverLevelData){
                serverLevelData = {};
            }
            leStore.setLevel('ranks', serverLevelData.detection_rank);
            leStore.setLevel('costs', serverLevelData.detection_cost);
            leStore.saveRemark(serverLevelData.detection_conclusion_comment);
        }
    }
});
