AuctionTypein.controller('ChooseCtrl', function($scope,$rootScope,$ionicPopup,$stateParams, DataService) {
    $scope.carType = DataService.carType;
    $scope.paiType = DataService.paiType;
    $scope.canSubmit = false;
    $scope.chooseCarType = function(type){
        $scope.carType = type;

    }
    $scope.id = 0;
    //如果带着参数进来，默认进去编辑此车辆信息的逻辑
    if($stateParams.carId){
        $scope.id = $stateParams.carId;
    }
    $scope.choosePaiType = function(type){
        $scope.paiType = type;

    }
    $scope.$watch("carType",function(){
        if($scope.carType!==""&&$scope.paiType!==""){
            $scope.canSubmit = true;
        }
    })
    $scope.$watch("paiType",function(){
        if($scope.carType!==""&&$scope.paiType!==""){
            $scope.canSubmit = true;
        }
    })
    $scope.back = function(){
        localStorage.setItem("cheniu_pubcar_data","");
         Jockey.send('ControlWebVCBridge', {
                            action: 'close'
                        });

    }
    $scope.save = function(e){
        if($(e.target).hasClass("disabeld")) return;
        DataService.carType = $scope.carType
        DataService.paiType = $scope.paiType
        if($scope.id){
            window.location.href = "#index/"+$scope.id
        }else{
            window.location.href = "#index"
        }

    }
    var restoreFromLocal = function(){
        try{
            var restoredata = localStorage.getItem("cheniu_pubcar_data")
            restoredata = JSON.parse(restoredata);
            return restoredata
        }catch(e){
            return null;
        }
    }
    //判断是否需要从本地恢复，然后恢复。
    var restoreData = restoreFromLocal();

    if(restoreData&&localStorage.getItem("cheniu_pubcar_data_first")){
        var myPopup = $ionicPopup.show({
            title: '判断到之前有未保存的数据，是否恢复？',
            scope: $scope,
            buttons: [
                { text: '恢复',
                    type: '',
                    onTap: function(e) {
                        localStorage.setItem("cheniu_pubcar_data","")
                        restoreData.pai_data&&DataService.setPaiData(restoreData.pai_data.data);
                        restoreData.detection_data&&DataService.setDetectData(restoreData.detection_data.data)
                        restoreData.basic_data&&DataService.setBasicData(restoreData.basic_data.data)
                        restoreData.pic_data&&DataService.setPicData(restoreData.pic_data.data)
                        $scope.carType = DataService.carType = restoreData.carType;
                        $scope.paiType = DataService.paiType = restoreData.paiType;
                        location.hash="#index"
                    }},
                {
                    text: '重新填写',
                    type: 'button-assertive theme-bg theme-border theme-color',
                    onTap: function(e) {
                        localStorage.setItem("cheniu_pubcar_data","")
                    }
                }
            ]
        });
    }
    if(!localStorage.getItem("cheniu_pubcar_data_first")){
        //如果是第一次判断，啥事都不干。用来去掉老的错乱数据
        localStorage.setItem("cheniu_pubcar_data_first","1")
        localStorage.setItem("cheniu_pubcar_data","")
    }
})