AuctionTypein.controller('UploadPicsCtrl', function($scope, $ionicModal, $ionicPopup ,DataService,$timeout){
    $scope.data={}
    $scope.pics = DataService.getPicData().data;
    //从url里获取md5值，废弃
    /*var getMD5 = function(filepath){
        var reg = /[^\/]+$/
        var md5_result = filepath.match(reg)
        var md5 = "";
        if(md5_result){
            md5 = md5_result[0]
        }
        if(md5.length<20){
            //android url:http://cheniu.u.qiniudn.com/15088615517/0000DADB597A3CE0D314B8341A9C7D2E/20141117183651
            md5_result = filepath.match(/\/([^\/]+)\/[^\/]+$/)
            if(md5_result){
                md5 = md5_result[1]
            }
        }
        return md5;
    }*/
    Jockey.send("SetRightBar",{
        title:"完成",
        show: 1
    })
    Jockey.send("SetWebViewTitle",{
        title: '图片信息'
    });
    window.rightButtonEvent = function(){
        $scope.back();
    }
    $scope.showupload = function(){
        Jockey.send('CapturePicBridge', {
            maxPicCount: 30-$scope.pics.length //用户最大可上传的照片数量
        }, function(data) {
            $scope.pics = $scope.pics.concat(data.urls);
            $scope.$digest();
        });
    }
    $scope.$watchCollection("pics",function(){ 
        DataService.setPicData($scope.pics)
    })
    $scope.previewPic = "";
    $scope.hidePreview = function(){
        $scope.previewModal.hide();
         window.CheNiu&&CheNiu.setNavColor(appColor)
    };
    $scope.del = function(){
        $scope.pics.forEach(function(p,i){
            if(p==$scope.previewPic){
                $scope.pics.splice(i,1)
            }
        })
        $scope.previewModal.hide();
    };
    $scope.previewModal;
    $ionicModal.fromTemplateUrl('templates/imgpreview.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.previewModal = modal;
    });
    $scope.preview = function(file){
        $scope.previewPic = file;
        $scope.previewModal.show();
        if(window.CheNiu){
            setTimeout(function(){
                window.CheNiu&&CheNiu.setNavColor("#111111")
            },300)

        }

    }
    $scope.back = function(){
        window.history.go(-1)
    }
    $scope.backCheck = function() {
        if (checkLegality()) {
            $scope.back();
        }
    };
    var picPuchCheck = function(pic) {
        $scope.pics.push(pic);
        if ($scope.pics.length > 12) {
            checkLegality();
        }
    };
    var checkLegality = function () {

        var strategies = {
            less: function(count) {
                return {
                    title: '图片数量不足',
                    subTitle: '您只发布了' + count + '张图片，至少需要发布' + 6 + '张图片'
                };
            },
            more: function(count) {
                return {
                    title: '图片数量过多',
                    subTitle: '您发布了' + count + '张图片， 最多只能发12张图片'
                }
            }
        };

        var popUp = function(strategy) {
            $ionicPopup.show({
                title: strategy.title,
                subTitle: strategy.subTitle,
                scope: $scope,
                buttons: [
                    {
                        text: '确定',
                        onTap: function (e) {
                            return false;
                        }
                    },
                ]
            });
        }

        var count = $scope.pics.length;

        if (count < 6) {
            popUp(strategies.less(count));
        } else if (count > 12) {
            popUp(strategies.more(count));
        } else {
            return true
        }

        return false;
    };
    $scope.movePic = function(index,to_index){
        if(index==to_index) return;
            var cache = $scope.pics[index]
        try{
            if(to_index<index){
                $scope.pics.splice(index,1)
                $scope.pics.splice(to_index,0,cache)
            }else{
                $scope.pics.splice(to_index+1,0,cache)
                $scope.pics.splice(index,1)
            }
        }catch(e){

        }

        $scope.$digest();

    }
});
